//---------------------------------------------------------------------------
/* This Component is FreeWare.

   If you have any problems or suggestions please feel free
   to contact me at zennyone@catcha.com

   If you improve or change the code, please be so kind to send me a copy.
   Use the component at your own risk. In releasing this code to the wider community
   no warranty is implied.

   Credits:
   ========
   Too many to name but borland.public.* as well as the people behind the various faqs.

   This small contribution of mine is an expression of my gratitude to this great
   community of people.
*/
#include <vcl.h>
#pragma hdrstop

#include "SlideJmpPanel.h"
#pragma package(smart_init)
#pragma resource "slideJmpPanel.res"

//---------------------------------------------------------------------------
// ValidCtrCheck is used to assure that the components created do not have
// any pure virtual functions.
//
static inline void ValidCtrCheck(TSlideJmpPanel *)
{
        new TSlideJmpPanel(NULL);
}
//---------------------------------------------------------------------------
__fastcall TSlideJmpPanel::TSlideJmpPanel(TComponent* Owner)
        : TPanel(Owner)
{
    // Set up to take over Parent's WindowProc. Parent can be any TWinControl component.
    Ow = Owner ;
    OldWndProc = dynamic_cast<TWinControl *>(Owner)->WindowProc;
    dynamic_cast<TWinControl *>(Owner)->WindowProc = MyWndProc ;

   // create handle panel
   FHP = new TPanel(this) ;
   FHP->Parent = this ;
   FHP->BevelOuter = bvNone ;
   FHP->BorderWidth = 1 ;
   FHP->Visible = true ;
   FHP->OnMouseDown = MouseDownOnHandle ;
   FHP->OnMouseMove = MouseMoveOnHandle ;
   FHP->OnMouseUp = MouseUpOnHandle ;

   // create Left, right , Up and down arrow image on panel
   LeftArr = new TImage(FHP);
   LeftArr->Parent = FHP ;
   LeftArr->Left = 1;
   LeftArr->Height = 51;
   LeftArr->Width = 8;
   LeftArr->Top = FHP->Height / 2 - 55 ;
   LeftArr->Picture->Bitmap->LoadFromResourceName((int)HInstance,"LEFTARR") ;
   LeftArr->Visible = false ;
   LeftArr->Cursor = crHandPoint  ;
   LeftArr->OnClick = LeftArrMouseClick ;

   RightArr = new TImage(FHP);
   RightArr->Parent = FHP ;
   RightArr->Top = FHP->Height /2 + 5 ;
   RightArr->Left = 1;
   RightArr->Height = 51;
   RightArr->Width = 8;
   RightArr->Picture->Bitmap->LoadFromResourceName((int)HInstance,"RIGHTARR") ;
   RightArr->Visible = false ;
   RightArr->Cursor = crHandPoint  ;
   RightArr->OnClick = RightArrMouseClick ;

   UpArr = new TImage(FHP);
   UpArr->Parent = FHP ;
   UpArr->Left = FHP->Width /2  - 51 ;
   UpArr->Top = 1;
   UpArr->Height = 8;
   UpArr->Width = 51;
   UpArr->Picture->Bitmap->LoadFromResourceName((int)HInstance,"UPARR") ;
   UpArr->Visible = false ;
   UpArr->Cursor = crHandPoint  ;
   UpArr->OnClick = UpArrMouseClick ;

   DownArr = new TImage(FHP);
   DownArr->Parent = FHP ;
   DownArr->Left = FHP->Width /2 + 5 ;
   DownArr->Top = 1;
   DownArr->Height = 8;
   DownArr->Width = 51;
   DownArr->Picture->Bitmap->LoadFromResourceName((int)HInstance,"DOWNARR") ;
   DownArr->Visible = false ;
   DownArr->Cursor = crHandPoint  ;
   DownArr->OnClick = DownArrMouseClick ;

   // Set all propeerties to their default
   HandlePosition = hpLeft ;
   MinSize = DefaultMinSize() ;
   MaxSize = 0 ;
   HandleVisible = true ;
   JmpHandleVisible = false ;

   HorPnlWidth = Width ;
   VerPnlHeight = Height ;
   spnlState = spMiddle ;

   ResizeDue2Jmp = false ;
   ResizeDue2Drag = false ;
   UpdateHandlePanel() ;
   FVersion = Version ;
   Start = true ;
}

__fastcall TSlideJmpPanel::~TSlideJmpPanel(void)
{
   ((TWinControl *)Ow)->WindowProc = OldWndProc;
   delete LeftArr ;
   delete RightArr ;
   delete UpArr ;
   delete DownArr ;
   delete FHP ;
}
//---------------------------------------------------------------------------
void __fastcall TSlideJmpPanel::MouseDownOnHandle(TObject *Sender , TMouseButton Button ,
           TShiftState Shift , int X, int Y )
{
   if (Button == mbLeft)
   {
      FPT = Point(X - CenterMargin , Y - CenterMargin) ;
      FPT = Parent->ScreenToClient(FHP->ClientToScreen(FPT)) ;

      FOF = Point(Left - FPT.x, Top - FPT.y) ;
      FMN = DefaultMinSize() ;

      if (MinSize > FMN)
        FMN = MinSize ;

      switch(FHandlePos)
      {
         case hpLeft :
         case hpRight:   FMX = Parent->Width ; break ;
         case hpTop  :
         case hpBottom:  FMX = Parent->Height; break ;
      }

      if (MaxSize > 0 && MaxSize >= MinSize && MaxSize < FMX)
          FMX = MaxSize ;

   }
}
//---------------------------------------------------------------------------
void __fastcall TSlideJmpPanel::MouseMoveOnHandle(TObject *Sender ,
           TShiftState Shift , int X, int Y )
{
   TPoint PT ;

   if (Shift.Contains(ssLeft))
   {
      PT = Point(X - CenterMargin, Y - CenterMargin) ;
      PT = Parent->ScreenToClient(FHP->ClientToScreen(PT)) ;

      switch(FHandlePos)
      {
         case hpLeft : if (((Width + (Left-(PT.x+ FOF.x))) >= FMN) &&
                           (PT.x > 0 ) && ((Width + (Left-(PT.x + FOF.x))) <= FMX))
                       {
                          Width = Width + (Left - (PT.x + FOF.x)) ;
                       }
                       break ;
         case hpRight: if (((PT.x - Left + HandleWidth) >= FMN) &&
                           ((PT.x - Left + HandleWidth) <= FMX) &&
                           (PT.x < ( Parent->Width - HandleWidth )))
                       {
                          Width = PT.x - Left + HandleWidth ;
                       }
                       break ;
         case hpTop:  if ( (( Height + (Top - (PT.y + FOF.y))) >= FMN) &&
                           (( Height + (Top - (PT.y + FOF.y))) <= FMX) &&
                           (PT.y > 0) )
                      {
                         Height = Height + (Top -(PT.y + FOF.y)) ;
                         Top = PT.y + FOF.y ;
                         Parent->Update() ;
                      }
                      break ;
         case hpBottom: if (((PT.y - Top + HandleWidth) >= FMN) &&
                            ((PT.y - Top + HandleWidth) <= FMX) &&
                            (PT.y < (Parent->Height - HandleWidth)) )
                       {
                          Height = PT.y - Top + HandleWidth ;
                       }
      }
   }
}
//---------------------------------------------------------------------------
void __fastcall TSlideJmpPanel::MouseUpOnHandle(TObject *Sender , TMouseButton Button ,
           TShiftState Shift , int X, int Y )
{

}
//---------------------------------------------------------------------------
int __fastcall TSlideJmpPanel::DefaultMinSize(void)
{
   int Size = HandleWidth ;

   Size += BorderWidth *2 ;
   if (BevelOuter != bvNone)
      Size += BevelWidth * 2 ;

   if (BevelInner != bvNone)
      Size += BevelWidth * 2 ;

   return Size ;

}
//---------------------------------------------------------------------------
void __fastcall TSlideJmpPanel::SetHandlePos(THandlePosition NewPos)
{
   if (NewPos != FHandlePos)
   {
      FHandlePos = NewPos ;
      if (FHandlePos == hpLeft || FHandlePos == hpRight)
      {
         LeftArr->Visible = true ;
         RightArr->Visible = true ;
         UpArr->Visible = false ;
         DownArr->Visible = false ;
      }
      else
         {
         LeftArr->Visible = false ;
         RightArr->Visible = false ;
         UpArr->Visible = true ;
         DownArr->Visible = true ;
         }
      UpdateHandlePanel() ; // Need to call twice for the effect to take hold.
      UpdateHandlePanel() ; // Do not know why but it works.
   }
}
//---------------------------------------------------------------------------
void __fastcall TSlideJmpPanel::SetHandleVisible(bool NewVis)
{
   if (NewVis != FHandleVisible)
   {
      FHandleVisible = NewVis ;
      UpdateHandlePanel() ;
   }
}
//---------------------------------------------------------------------------
void __fastcall TSlideJmpPanel::SetJmpHandleVisible(bool NewHandleVis)
{
   if (NewHandleVis != FJmpHandleVisible)
   {
      FJmpHandleVisible = NewHandleVis ;
      UpdateHandlePanel() ;
   }

}
//---------------------------------------------------------------------------
void __fastcall TSlideJmpPanel::UpdateHandlePanel(void)
{

   if (FHandlePos == hpLeft || FHandlePos == hpRight)
   {
      RightArr->Top = FHP->Height /2 + 5 ;
      LeftArr->Top = FHP->Height /2 - 55 ;
      RightArr->Refresh() ;
      LeftArr->Refresh() ;
   }
   else
      {
         UpArr->Left = FHP->Width / 2 - 51 ;
         DownArr->Left = FHP->Width /2 + 5 ;
         UpArr->Refresh() ;
         DownArr->Refresh() ;
      }

   if (FHandleVisible)
   {
      FHP->BevelInner = bvRaised ;
      if (FHandlePos == hpRight )
      {
        RightArr->Visible = FJmpHandleVisible  && (spnlState == spMiddle || spnlState == spHidden) ;
        LeftArr->Visible = FJmpHandleVisible && (spnlState == spMiddle || spnlState == spFull) ;
        RightArr->Refresh() ;
        LeftArr->Refresh() ;
      }
      else if (FHandlePos == hpLeft)
      {
        RightArr->Visible = FJmpHandleVisible  && (spnlState == spMiddle || spnlState ==spFull) ;
        LeftArr->Visible = FJmpHandleVisible && (spnlState == spMiddle || spnlState == spHidden) ;
        RightArr->Refresh() ;
        LeftArr->Refresh() ;
      }
      else if (FHandlePos == hpTop)
          {
             UpArr->Visible = FJmpHandleVisible && (spnlState == spMiddle || spnlState == spHidden) ;
             DownArr->Visible = FJmpHandleVisible && (spnlState == spMiddle || spnlState == spFull) ;

             UpArr->Refresh() ;
             DownArr->Refresh() ;
          }
      else
          {
             UpArr->Visible = FJmpHandleVisible && (spnlState == spMiddle || spnlState == spFull) ;
             DownArr->Visible = FJmpHandleVisible && (spnlState == spMiddle || spnlState == spHidden) ;
             UpArr->Refresh() ;
             DownArr->Refresh() ;
         }
   }
   else
      {
         FHP->BevelInner = bvNone ;
         RightArr->Visible = false ;
         LeftArr->Visible = false ;
         UpArr->Visible = false ;
         DownArr->Visible = false ;
         RightArr->Refresh() ;
         LeftArr->Refresh() ;
         UpArr->Refresh() ;
         DownArr->Refresh() ;
      }

   switch(FHandlePos)
   {
     case hpLeft: FHP->Align = alLeft ;
                  FHP->Width = HandleWidth ;
                  if (spnlState == spFull)
                     FHP->Cursor = crIBeam ;
                  else
                     FHP->Cursor = crHSplit ;
                  break ;
     case hpRight:FHP->Align = alRight ;
                  FHP->Width = HandleWidth ;
                  if (spnlState == spFull)
                     FHP->Cursor = crIBeam ;
                  else
                     FHP->Cursor = crHSplit ;

                  break ;
     case hpTop  :FHP->Align = alTop ;
                  FHP->Width = HandleWidth ;

                  if (spnlState == spFull)
                     FHP->Cursor = crIBeam ;
                  else
                     FHP->Cursor = crVSplit ;

                  break ;
     case hpBottom:FHP->Align = alBottom ;
                  FHP->Width = HandleWidth ;
                  if (spnlState == spFull)
                     FHP->Cursor = crIBeam ;
                  else
                     FHP->Cursor = crVSplit ;

                  break ;
   }

   // For debugging
   //Caption = "HorPnlWidth :  " + IntToStr(HorPnlWidth) + "  VerPnlHeight : " + IntToStr(VerPnlHeight) ;
}

void __fastcall TSlideJmpPanel::LeftArrMouseClick(TObject *Sender)
{
    ResizeDue2Jmp = true ;

    if (spnlState == spMiddle)
    {
       if (HandlePosition == hpLeft)
       {
           HorPnlWidth = Width ;
           spnlState = spFull ;
           Width = Parent->Width - 10 ;
           LeftArr->Visible = false ;
       }
       else if (HandlePosition == hpRight)
       {
          HorPnlWidth = Width ;
          Width = 10 ;
          spnlState = spHidden ;
          LeftArr->Visible = false ;
       }
    }
    // LeftArr event occur only if handleposition == hpRight - for spFull state
    // or handleposition == hpLeft for spHidden state
    else if (spnlState == spFull || spnlState == spHidden)
    {
       Width = HorPnlWidth ;
       spnlState = spMiddle ;
       LeftArr->Visible = true ;
       RightArr->Visible = true ;
    }

    LeftArr->Refresh() ;
    RightArr->Refresh() ;
}

void __fastcall TSlideJmpPanel::RightArrMouseClick(TObject *Sender)
{
    ResizeDue2Jmp = true ;

    if (spnlState == spMiddle)
    {
       if (HandlePosition == hpRight)
       {
          HorPnlWidth = Width ;
          Width = Parent->Width -10 ;
          spnlState = spFull ;
          LeftArr->Visible = true ;
          RightArr->Visible = false ;
       }
       else if (HandlePosition == hpLeft)
       {
           HorPnlWidth = Width ;
           Width = 10 ;
           spnlState = spHidden ;
           LeftArr->Visible = true ;
           RightArr->Visible = false ;
       }
    }
    else if (spnlState == spFull || spnlState == spHidden)
      {
         Width = HorPnlWidth ;
         spnlState = spMiddle ;
         LeftArr->Visible = true ;
         RightArr->Visible = true ;
      }


    LeftArr->Refresh() ;
    RightArr->Refresh() ;
}

void __fastcall TSlideJmpPanel::UpArrMouseClick(TObject *Sender)
{
  ResizeDue2Jmp = true ;
  if (spnlState == spMiddle)
  {
     if (HandlePosition == hpBottom)
     {
        VerPnlHeight = Height ;
        Height = 8 ;
        spnlState = spHidden ;
        DownArr->Visible = true ;
        UpArr->Visible = false ;
     }
     else if (HandlePosition == hpTop)
     {
        VerPnlHeight = Height ;
        Height = Parent->ClientHeight  ;
        spnlState = spFull ;
        DownArr->Visible = true ;
        UpArr->Visible = false ;
     }
  }
  else if (spnlState == spFull || spnlState == spHidden)
  {
     Height = VerPnlHeight ;
     spnlState = spMiddle ;
     UpArr->Visible = true ;
     DownArr->Visible = true ;
  }

  DownArr->Refresh() ;
  UpArr->Refresh() ;
}

void __fastcall TSlideJmpPanel::DownArrMouseClick(TObject *Sender)
{
   ResizeDue2Jmp = true ;
   if (spnlState == spMiddle)
   {
      if (HandlePosition == hpBottom)
      {
         VerPnlHeight = Height ;
         Height = Parent->ClientHeight  ;
         spnlState = spFull ;
         DownArr->Visible = false ;
         UpArr->Visible = true ;
       }
      else if (HandlePosition == hpTop)
      {
         VerPnlHeight = Height ;
         Height = 8 ;
         spnlState = spHidden ;

         DownArr->Visible = false ;
         UpArr->Visible = true ;
      }
   }
   else if (spnlState == spHidden || spnlState == spFull)
        {
         Height = VerPnlHeight ;
         spnlState = spMiddle ;
         UpArr->Visible = true ;
         DownArr->Visible = true ;
        }

  DownArr->Refresh() ;
  UpArr->Refresh() ;


}
//---------------------------------------------------------------------------
void __fastcall TSlideJmpPanel::Resize(void)
{
     TPanel::Resize() ;

     if (Start)
     {
        ParClientHeight = Parent->ClientHeight ;
        Start = false ;
     }

     if (!ResizeDue2Jmp && !ClientResize)
     {   if (FHandlePos == hpLeft || FHandlePos == hpRight)
           HorPnlWidth = Width ;
        else
           VerPnlHeight = Height ;
     }
     else
     {
          ResizeDue2Jmp = false ;
          ClientResize = false ;
     }

     UpdateHandlePanel() ;
}

void __fastcall TSlideJmpPanel::MyWndProc(TMessage &Message)
{

   OldWndProc(Message) ;  // Parent's - Owner's WndProc ()
   if (Message.Msg == WM_SIZE && spnlState != spHidden)
   {
     ClientResize  = true ;
     switch(FHandlePos)
     {
       case hpBottom :   if (Parent->ClientHeight > Height)
                         {
                           UpArr->Visible = true ;
                           DownArr->Visible = true ;
                           spnlState = spMiddle ;
                         }
                         else
                            {
                                UpArr->Visible = true ;
                                DownArr->Visible = false ;
                                Height = Parent->ClientHeight ;
                                spnlState = spFull ;
                                VerPnlHeight = Height / 2 ;
                             }
                         UpdateHandlePanel() ;
                         break ;

       case hpTop  : if (Parent->ClientHeight <= Height)
                     {
                        Caption = "CH < H  -- CH : " + IntToStr(Parent->ClientHeight) + "  H : " + IntToStr(Height) ;
                        UpArr->Visible = false ;
                        DownArr->Visible = true ;
                        spnlState = spFull ;
                        Height = Parent->ClientHeight ;
                        VerPnlHeight = Height / 2 ;
                        ParClientHeight = Parent->ClientHeight ;
                     }
                     else
                     {
                        Caption = "CH < H  -- CH : " + IntToStr(Parent->ClientHeight) + "  H : " + IntToStr(Height) ;
                        UpArr->Visible = true ;
                        DownArr->Visible = true ;
                        spnlState = spMiddle ;
                     }
                     UpdateHandlePanel() ;
                     break ;

       case hpRight : if (Parent->ClientWidth > Width)
                      {
                          RightArr->Visible = true ;
                          LeftArr->Visible = true ;
                          spnlState = spMiddle ;
                      }
                      else
                          {
                             RightArr->Visible = false ;
                             LeftArr->Visible = true ;
                             spnlState = spFull ;
                             Width = Parent->ClientWidth ;
                             HorPnlWidth = Width /2 ;
                          }

                      UpdateHandlePanel() ;
                      break ;
       case hpLeft : if (Parent->ClientWidth > Width)
                     {
                          LeftArr->Visible = true ;
                          spnlState = spMiddle ;
                         RightArr->Visible = true ;
                     }
                     else
                       {
                          LeftArr->Visible = false ;
                          RightArr->Visible = true ;
                          spnlState = spFull ;
                          Width = Parent->ClientWidth ;
                          HorPnlWidth = Width / 2 ;
                       }
                     UpdateHandlePanel() ;

        }
   }
}

namespace Slidejmppanel
{
        void __fastcall PACKAGE Register()
        {
                 TComponentClass classes[1] = {__classid(TSlideJmpPanel)};
                 RegisterComponents("Standard", classes, 0);
        }
}
//---------------------------------------------------------------------------



